-- Kranteleskop
--
-- M@D Author  Headshot XXL   &   Gorli
-- M@D date  29.04.2009
--
-- > Copyright (C) Headshot XXL & Gorli< --
-- > erweitert (C) 2011 Bauer Wolle< --

Kranteleskop = {}

function Kranteleskop.prerequisitesPresent(specializations)
	Vehicle.registerJointType("frontloader");
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function Kranteleskop:load(xmlFile)
	
	local translationPartNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart#index"));
    if translationPartNode ~= nil then
        self.translationPart = {};
        self.translationPart.node = translationPartNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#minTrans"));
        self.translationPart.minTrans = {};
        self.translationPart.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart#maxTrans"));
        self.translationPart.maxTrans = {};
        self.translationPart.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#transTime"), 2)*1000;
        self.translationPart.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart#touchTransLimit"), 10);
    end;
    local translationPartNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart2#index"));
    if translationPartNode2 ~= nil then
        self.translationPart2 = {};
        self.translationPart2.node = translationPartNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#minTrans"));
        self.translationPart2.minTrans = {};
        self.translationPart2.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart2#maxTrans"));
        self.translationPart2.maxTrans = {};
        self.translationPart2.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart2.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart2.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart2.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#transTime"), 2)*1000;
        self.translationPart2.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart2#touchTransLimit"), 10);
    end; 
 
	local translationPartNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart3#index"));
    if translationPartNode3 ~= nil then
        self.translationPart3 = {};
        self.translationPart3.node = translationPartNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#minTrans"));
        self.translationPart3.minTrans = {};
        self.translationPart3.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart3#maxTrans"));
        self.translationPart3.maxTrans = {};
        self.translationPart3.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart3.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart3.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart3.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#transTime"), 2)*1000;
        self.translationPart3.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart3#touchTransLimit"), 10);
    end; 
    local translationPartNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart4#index"));
    if translationPartNode4 ~= nil then
        self.translationPart4 = {};
        self.translationPart4.node = translationPartNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#minTrans"));
        self.translationPart4.minTrans = {};
        self.translationPart4.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart4#maxTrans"));
        self.translationPart4.maxTrans = {};
        self.translationPart4.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart4.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart4.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart4.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#transTime"), 2)*1000;
        self.translationPart4.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart4#touchTransLimit"), 10);
    end; 
        local translationPartNode5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart5#index"));
    if translationPartNode5 ~= nil then
        self.translationPart5 = {};
        self.translationPart5.node = translationPartNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart5#minTrans"));
        self.translationPart5.minTrans = {};
        self.translationPart5.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart5.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart5.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart5#maxTrans"));
        self.translationPart5.maxTrans = {};
        self.translationPart5.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart5.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart5.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart5.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart5#transTime"), 2)*1000;
        self.translationPart5.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart5#touchTransLimit"), 10);
    end; 
	
    local translationPartNode6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart6#index"));
    if translationPartNode6 ~= nil then
        self.translationPart6 = {};
        self.translationPart6.node = translationPartNode6;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart6#minTrans"));
        self.translationPart6.minTrans = {};
        self.translationPart6.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart6.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart6.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart6#maxTrans"));
        self.translationPart6.maxTrans = {};
        self.translationPart6.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart6.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart6.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart6.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart6#transTime"), 2)*1000;
        self.translationPart6.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart6#touchTransLimit"), 10);
    end; 
 
	local translationPartNode7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart7#index"));
    if translationPartNode7 ~= nil then
        self.translationPart7 = {};
        self.translationPart7.node = translationPartNode7;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart7#minTrans"));
        self.translationPart7.minTrans = {};
        self.translationPart7.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart7.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart7.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart7#maxTrans"));
        self.translationPart7.maxTrans = {};
        self.translationPart7.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart7.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart7.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart7.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart7#transTime"), 2)*1000;
        self.translationPart7.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart7#touchTransLimit"), 10);
    end; 
    local translationPartNode8 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart8#index"));
    if translationPartNode8 ~= nil then
        self.translationPart8 = {};
        self.translationPart8.node = translationPartNode8;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart8#minTrans"));
        self.translationPart8.minTrans = {};
        self.translationPart8.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart8.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart8.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart8#maxTrans"));
        self.translationPart8.maxTrans = {};
        self.translationPart8.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart8.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart8.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart8.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart8#transTime"), 2)*1000;
        self.translationPart8.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart8#touchTransLimit"), 10);
    end; 
        local translationPartNode9 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart9#index"));
    if translationPartNode9 ~= nil then
        self.translationPart9 = {};
        self.translationPart9.node = translationPartNode9;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart9#minTrans"));
        self.translationPart9.minTrans = {};
        self.translationPart9.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart9.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart9.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart9#maxTrans"));
        self.translationPart9.maxTrans = {};
        self.translationPart9.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart9.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart9.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart9.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart9#transTime"), 2)*1000;
        self.translationPart9.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart9#touchTransLimit"), 10);
    end; 
        
       
 
   
	local rotationNode1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation1#index"));
    if rotationNode1 ~= nil then
        self.rotation1 = {};
        self.rotation1.node = rotationNode1;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#minRot"));
        self.rotation1.minRot = {};
        self.rotation1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation1#maxRot"));
        self.rotation1.maxRot = {};
        self.rotation1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#rotTime"), 2)*1000;
        self.rotation1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation1#touchRotLimit"), 10));
    end;
	
    local rotationNode2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation2#index"));
    if rotationNode2 ~= nil then
        self.rotation2 = {};
        self.rotation2.node = rotationNode2;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#minRot"));
        self.rotation2.minRot = {};
        self.rotation2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation2#maxRot"));
        self.rotation2.maxRot = {};
        self.rotation2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#rotTime"), 2)*1000;
        self.rotation2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation2#touchRotLimit"), 10));
    end;
    local rotationNode3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation3#index"));
    if rotationNode3 ~= nil then
        self.rotation3 = {};
        self.rotation3.node = rotationNode3;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#minRot"));
        self.rotation3.minRot = {};
        self.rotation3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation3#maxRot"));
        self.rotation3.maxRot = {};
        self.rotation3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#rotTime"), 2)*1000;
        self.rotation3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation3#touchRotLimit"), 10));
    end;
    local rotationNode4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation4#index"));
    if rotationNode4 ~= nil then
        self.rotation4 = {};
        self.rotation4.node = rotationNode4;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation4#minRot"));
        self.rotation4.minRot = {};
        self.rotation4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation4#maxRot"));
        self.rotation4.maxRot = {};
        self.rotation4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation4#rotTime"), 2)*1000;
        self.rotation4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation4#touchRotLimit"), 10));
    end;
    local rotationNode5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation5#index"));
    if rotationNode5 ~= nil then
        self.rotation5 = {};
        self.rotation5.node = rotationNode5;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#minRot"));
        self.rotation5.minRot = {};
        self.rotation5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation5#maxRot"));
        self.rotation5.maxRot = {};
        self.rotation5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation5#rotTime"), 2)*1000;
        self.rotation5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation5#touchRotLimit"), 10));
    end;
    local rotationNode6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation6#index"));
    if rotationNode6 ~= nil then
        self.rotation6 = {};
        self.rotation6.node = rotationNode6;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation6#minRot"));
        self.rotation6.minRot = {};
        self.rotation6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation6#maxRot"));
        self.rotation6.maxRot = {};
        self.rotation6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation6#rotTime"), 2)*1000;
        self.rotation6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation6#touchRotLimit"), 10));
    end;
    local rotationNode7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation7#index"));
    if rotationNode7 ~= nil then
        self.rotation7 = {};
        self.rotation7.node = rotationNode7;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation7#minRot"));
        self.rotation7.minRot = {};
        self.rotation7.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation7.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation7.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation7#maxRot"));
        self.rotation7.maxRot = {};
        self.rotation7.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation7.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation7.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation7.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation7#rotTime"), 2)*1000;
        self.rotation7.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation7#touchRotLimit"), 10));
    end;
    local rotationNode11 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation11#index"));
    if rotationNode11 ~= nil then
        self.rotation11 = {};
        self.rotation11.node = rotationNode11;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation11#minRot"));
        self.rotation11.minRot = {};
        self.rotation11.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation11.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation11.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation11#maxRot"));
        self.rotation11.maxRot = {};
        self.rotation11.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation11.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation11.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation11.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation11#rotTime"), 2)*1000;
        self.rotation11.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation11#touchRotLimit"), 10));
    end;
	
    local rotationNode12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation12#index"));
    if rotationNode12 ~= nil then
        self.rotation12 = {};
        self.rotation12.node = rotationNode12;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation12#minRot"));
        self.rotation12.minRot = {};
        self.rotation12.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation12.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation12.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation12#maxRot"));
        self.rotation12.maxRot = {};
        self.rotation12.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation12.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation12.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation12.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation12#rotTime"), 2)*1000;
        self.rotation12.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation12#touchRotLimit"), 10));
    end;
    local rotationNode13 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation13#index"));
    if rotationNode13 ~= nil then
        self.rotation13 = {};
        self.rotation13.node = rotationNode13;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation13#minRot"));
        self.rotation13.minRot = {};
        self.rotation13.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation13.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation13.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation13#maxRot"));
        self.rotation13.maxRot = {};
        self.rotation13.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation13.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation13.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation13.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation13#rotTime"), 2)*1000;
        self.rotation13.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation13#touchRotLimit"), 10));
    end;
    local rotationNode14 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation14#index"));
    if rotationNode14 ~= nil then
        self.rotation14 = {};
        self.rotation14.node = rotationNode14;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation14#minRot"));
        self.rotation14.minRot = {};
        self.rotation14.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation14.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation14.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation14#maxRot"));
        self.rotation14.maxRot = {};
        self.rotation14.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation14.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation14.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation14.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation14#rotTime"), 2)*1000;
        self.rotation14.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation14#touchRotLimit"), 10));
    end;
end;
      
function Kranteleskop:delete()
end;

function Kranteleskop:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function Kranteleskop:keyEvent(unicode, sym, modifier, isDown)
if sym == Input.KEY_KP_9 then
		self.translationMax = isDown;
		self.translationMax2 = isDown;
                self.translationMax3 = isDown;
		             
	end;
	if sym == Input.KEY_KP_6 then
		self.translationMin = isDown;
		self.translationMin2 = isDown;
                self.translationMin3 = isDown;
		            
	end;        
       
       
        if sym == Input.KEY_k then
		self.translationMax5 = isDown; 
                self.translationMax6 = isDown;
                self.translationMax7= isDown;
		self.translationMax8 = isDown;
        end;  
        if sym == Input.KEY_l then
		self.translationMin5 = isDown;
                self.translationMin6 = isDown;
                self.translationMin7 = isDown;
		self.translationMin8 = isDown;
        end;     
        
       
        

	if sym == Input.KEY_x then
		self.rotation1Max = isDown;
	end;
	if sym == Input.KEY_n then
		self.rotation1Min = isDown;
	end;
	if sym == Input.KEY_KP_7 then
		self.rotation2Max = isDown;
	end;
	if sym == Input.KEY_KP_4 then
		self.rotation2Min = isDown;
	end;
	if sym == Input.KEY_KP_5 then
		self.rotation3Max = isDown;
	end;
	if sym == Input.KEY_KP_8 then
		self.rotation3Min = isDown;
	end;
        if sym == Input.KEY_u then
		self.rotation11Max = isDown;
	end;
	if sym == Input.KEY_z then
		self.rotation11Min = isDown;
	end;
	if sym == Input.KEY_7 then
		self.rotation12Max = isDown;
	end;
	if sym == Input.KEY_6 then
		self.rotation12Min = isDown;
	end;
	if sym == Input.KEY_9 then
		self.rotation13Max = isDown;
	end;
	if sym == Input.KEY_8 then
		self.rotation13Min = isDown;
	end;
        if sym == Input.KEY_t then
		self.rotation14Max = isDown;
	end;
	if sym == Input.KEY_g then
		self.rotation14Min = isDown;
	end;
	if sym == Input.KEY_m then
		self.rotation4Max = isDown;
                self.rotation5Max = isDown;
                self.rotation6Max = isDown;
                self.rotation7Max = isDown;
	end;
	if sym == Input.KEY_j then
		self.rotation4Min = isDown;
                self.rotation5Min = isDown;
                self.rotation6Min = isDown;
                self.rotation7Min = isDown;
	end;       

end;      
  


function Kranteleskop:update(dt)
	
	local doTranslate = self.translationMax or self.translationMin 
	if self.translationPart ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart.maxTrans, self.translationPart.minTrans, 3, self.translationPart.transTime, dt, not self.translationMax); 
		setTranslation(self.translationPart.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax2 or self.translationMin2 
	if self.translationPart2 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart2.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart2.maxTrans, self.translationPart2.minTrans, 3, self.translationPart2.transTime, dt, not self.translationMax2); 
		setTranslation(self.translationPart2.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax3 or self.translationMin3 
	if self.translationPart3 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart3.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart3.maxTrans, self.translationPart3.minTrans, 3, self.translationPart3.transTime, dt, not self.translationMax3); 
		setTranslation(self.translationPart3.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax4 or self.translationMin4 
	if self.translationPart4 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart4.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart4.maxTrans, self.translationPart4.minTrans, 3, self.translationPart4.transTime, dt, not self.translationMax4); 
		setTranslation(self.translationPart4.node, unpack(newTrans)); 
	end;
                local doTranslate = self.translationMax5 or self.translationMin5 
	if self.translationPart5 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart5.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart5.maxTrans, self.translationPart5.minTrans, 3, self.translationPart5.transTime, dt, not self.translationMax5); 
		setTranslation(self.translationPart5.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax6 or self.translationMin6 
	if self.translationPart6 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart6.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart6.maxTrans, self.translationPart6.minTrans, 3, self.translationPart6.transTime, dt, not self.translationMax6); 
		setTranslation(self.translationPart6.node, unpack(newTrans)); 
	end;
	local doTranslate = self.translationMax7 or self.translationMin7 
	if self.translationPart7 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart7.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart7.maxTrans, self.translationPart7.minTrans, 3, self.translationPart7.transTime, dt, not self.translationMax7); 
		setTranslation(self.translationPart7.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax8 or self.translationMin8 
	if self.translationPart8 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart8.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart8.maxTrans, self.translationPart8.minTrans, 3, self.translationPart8.transTime, dt, not self.translationMax8); 
		setTranslation(self.translationPart8.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax9 or self.translationMin9 
	if self.translationPart9 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart9.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart9.maxTrans, self.translationPart9.minTrans, 3, self.translationPart9.transTime, dt, not self.translationMax9); 
		setTranslation(self.translationPart9.node, unpack(newTrans)); 
	end;
             
       

        
	local doRotate = self.rotation1Max or self.rotation1Min 
	if self.rotation1 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation1.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation1.maxRot, self.rotation1.minRot, 3, self.rotation1.rotTime, dt, not self.rotation1Max);
        setRotation(self.rotation1.node, unpack(newRot));
    end;
	
	local doRotate = self.rotation2Max or self.rotation2Min 
	if self.rotation2 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation2.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation2.maxRot, self.rotation2.minRot, 3, self.rotation2.rotTime, dt, not self.rotation2Max);
        setRotation(self.rotation2.node, unpack(newRot));
    end;
    local doRotate = self.rotation3Max or self.rotation3Min 
	if self.rotation3 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation3.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation3.maxRot, self.rotation3.minRot, 3, self.rotation3.rotTime, dt, not self.rotation3Max);
        setRotation(self.rotation3.node, unpack(newRot));
    end;
    local doRotate = self.rotation4Max or self.rotation4Min
	if self.rotation4 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation4.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation4.maxRot, self.rotation4.minRot, 3, self.rotation4.rotTime, dt, not self.rotation4Max);
        setRotation(self.rotation4.node, unpack(newRot));
    end;
    local doRotate = self.rotation5Max or self.rotation5Min 
	if self.rotation5 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation5.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation5.maxRot, self.rotation5.minRot, 3, self.rotation5.rotTime, dt, not self.rotation5Max);
        setRotation(self.rotation5.node, unpack(newRot));
    end;
    local doRotate = self.rotation6Max or self.rotation6Min 
	if self.rotation6 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation6.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation6.maxRot, self.rotation6.minRot, 3, self.rotation6.rotTime, dt, not self.rotation6Max);
        setRotation(self.rotation6.node, unpack(newRot));
    end;
    local doRotate = self.rotation7Max or self.rotation7Min
	if self.rotation7 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation7.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation7.maxRot, self.rotation7.minRot, 3, self.rotation7.rotTime, dt, not self.rotation7Max);
        setRotation(self.rotation7.node, unpack(newRot));
    end;
local doRotate = self.rotation11Max or self.rotation11Min 
	if self.rotation11 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation11.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation11.maxRot, self.rotation11.minRot, 3, self.rotation11.rotTime, dt, not self.rotation11Max);
        setRotation(self.rotation11.node, unpack(newRot));
    end;
	
	local doRotate = self.rotation12Max or self.rotation12Min 
	if self.rotation12 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation12.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation12.maxRot, self.rotation12.minRot, 3, self.rotation12.rotTime, dt, not self.rotation12Max);
        setRotation(self.rotation12.node, unpack(newRot));
    end;
    local doRotate = self.rotation13Max or self.rotation13Min 
	if self.rotation13 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation13.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation13.maxRot, self.rotation13.minRot, 3, self.rotation13.rotTime, dt, not self.rotation13Max);
        setRotation(self.rotation13.node, unpack(newRot));
    end;
    local doRotate = self.rotation14Max or self.rotation14Min 
	if self.rotation14 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation14.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation14.maxRot, self.rotation14.minRot, 3, self.rotation14.rotTime, dt, not self.rotation14Max);
        setRotation(self.rotation14.node, unpack(newRot));
    end;
end;

function Kranteleskop:draw()
end;

function Kranteleskop:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
